;JFW scripts for WinMX 3.31 & 3.53
;script version 1.1  
;written by Leo Maria Cerreta

Include "common.jsm" ; message file
Include "HjGlobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
include "WinMxLangIta.jsh";user interface italian language of WinMx
include "WinMx.jsm"; message file of WinMX scripts

Globals
string SearchWindowsList,
handle LastFocusedWindow2, 
Int HelpKeys,
Int nKeyboardHelpSavePunctuation,
Int nKeyboardHelpSavedTypingEcho, 
Int ClipboardTextChanged, 
int WindowClosed,
int giSuppressStartMenu,
Int iWin95,
Int FirstStart,
handle LastFocusedWindow

const
IdDownloadsList = 1514,
IdUploadsList = 1515,
IdResultsList=1520,
IdEditSearch=1500,
IdStartSearch=1507,
IdSearchInNewWnd=1508,
IdStopSearch=1509,
IdCloseSearch=1510,
IdDownload=1515

Script gotoignored ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JawsCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "Ignored", s_top, s_unrestricted) Then
LeftMouseButton ()
ElIf FindString (GetCurrentWindow (), Ignored, s_top, S_unrestricted) Then
LeftMouseButton () 
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
RestoreCursor ()
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Script gotosettings ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "Settings", s_top, s_unrestricted) Then
LeftMouseButton ()
ElIf FindString (GetCurrentWindow (), Settings, s_top, s_unrestricted) Then
LeftMouseButton () 
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
RestoreCursor ()
Else SayFormattedMessage (Ot_Error, FindError2) 
EndIf
EndScript

Script gotohelp ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "help", s_top, s_unrestricted) Then
LeftMouseButton ()
ElIf FindString (GetCurrentWindow (), help, s_top, s_unrestricted) Then
LeftMouseButton () 
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
RestoreCursor ()
Else SayFormattedMessage (Ot_Error, FindError2) 
EndIf
EndScript

Script gotonetworks ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "networks", s_top, s_unrestricted) Then
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "finestra networks")
ElIf FindString (GetCurrentWindow (), networks, s_top, s_unrestricted) Then
LeftMouseButton () 
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "finestra networks")
Else RestoreCursor ()
SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Script gotosharedfiles ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "Shared Files", s_top, s_unrestricted) Then
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "files condivisi")
ElIf FindString (GetCurrentWindow (), SharedFiles, s_top, s_unrestricted) Then
LeftMouseButton () 
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "files condivisi")
Else RestoreCursor ()
SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Script gotochat ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "chat", s_top, s_unrestricted) Then
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "finestra chat")
ElIf FindString (GetCurrentWindow (), chat, s_top, s_unrestricted) Then
LeftMouseButton () 
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "finestra chat")
Else RestoreCursor ()
SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Void Function OpenSelectedItem (int ItemIndex)
var
int IndexWnd,
handle Hwnd,
string ItemName

let itemIndex = itemIndex - 1
let hwnd = GetFirstChild (GetForegroundWindow ())
if IsSearchWindow(hwnd) then
let indexWnd = indexWnd + 1
EndIf
While indexWnd != ItemIndex  
let hwnd = GetNextWindow(hwnd)
if IsSearchWindow(hwnd) then
let indexWnd = indexWnd + 1
EndIf
endWhile
let ItemName = GetWindowName(hwnd)
SaveCursor ()
If FindString (GetForegroundWindow (), ItemName, s_top, s_restricted) Then
LeftMouseButton ()
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
RestoreCursor ()
EndFunction

Script SelectSearch ()
var
Int SelectedItem 

If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
let SearchWindowsList = GetSearchWindows ()
if StringContains (SearchWindowsList , "|") Then
let LastFocusedWindow2 = GetFocus()
let SelectedItem = DlgSelectItemInList (SearchWindowsList, SelectSearchWindow, false)
if SelectedItem == 0 then
Pause ()
SetFocus (LastFocusedWindow2)
elif SelectedItem == 1 then
Pause ()
SpeechOff ()
gotosearch ()
Pause ()
SpeechOn ()
PerformScript OpenNewSearch ()
elif SelectedItem == 2 then
Pause ()
gotosearch ()
Pause ()
performScript GoToEditSearch ()
else pause ()
SpeechOff ()
gotosearch ()
Pause ()
SpeechOn ()
OpenSelectedItem(SelectedItem)
EndIf
else SayFormattedMessage (OT_SELECT, "ricerca")
gotosearch ()
EndIf
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Void Function gotosearch ()
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "Search", s_top, s_unrestricted) Then
LeftMouseButton ()
ElIf FindString (GetCurrentWindow (), search, s_top, s_unrestricted) Then
LeftMouseButton () 
Else RestoreCursor ()
SayFormattedMessage (Ot_Error, FindError1)
Return
EndIf
RestoreCursor ()
EndFunction

Script gotohotlist ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "Hotlist", s_top, s_unrestricted) Then
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "finestra contatti")
ElIf FindString (GetCurrentWindow (), Hotlist, s_top, s_unrestricted) Then
LeftMouseButton () 
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "finestra contatti")
Else RestoreCursor ()
SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Script gototransfers ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "Transfers", s_top, s_unrestricted) Then
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "trasferimenti")
Pause ()
PerformScript GoToResultsOrDownloadsList()
ElIf FindString (GetCurrentWindow (), Transfers, s_top, s_unrestricted) Then
LeftMouseButton () 
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "trasferimenti")
Pause ()
PerformScript GoToResultsOrDownloadsList()
Else RestoreCursor ()
SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Script gotobandwidth ()
If GetWindowName(GetAppMainWindow (getfocus())) == GetWindowName(GetRealWindow(getfocus())) Then
SaveCursor()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
NextLine ()
JAWSHome ()
If FindString (GetCurrentWindow (), "Bandwidth", s_top, s_unrestricted) Then
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "regolazioni di banda")
ElIf FindString (GetCurrentWindow (), Bandwidth, s_top, s_unrestricted) Then
LeftMouseButton () 
RestoreCursor ()
SayFormattedMessage (OT_SELECT, "regolazioni di banda")
Else RestoreCursor ()
SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, FindError2)
EndIf
EndScript

Script ContextMenu ()
If not HelpKeys Then
SaveCursor ()
RouteJAWSToPc ()
RightMouseButton ()
RestoreCursor ()
EndIf
EndScript

/*
Script prova ()
SayInteger(GetAppMainWindow (GetFocus()))
SayInteger(GetTopLevelWindow(GetFocus()))
SayInteger(GetRealWindow(GetFocus()))
SayInteger(getforegroundwindow())
EndScript
*/

Script closeWindow ()
If GetCurrentControlID () == 1514 && GetWindowClass(GetFocus()) == "SysListView32" Then
CloseWinmxWindow()
Elif GetCurrentControlID () == 1515 && GetWindowClass(GetFocus()) == "SysListView32" Then
CloseWinmxWindow ()
Else {alt+F4}
Pause ()
EndIf
EndScript

Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
If nKey == 93 Then
PerformScript ContextMenu()
EndIf
;original code
let WindowClosed = false;
let ClipboardTextChanged = false
If UserBufferIsActive () && UserBufferIsTrappingKeys() then
	If NKey == KEY_LEFT_WINDOWS || 
	nKey == KEY_RIGHT_WINDOWS || 
	nKey == KEY_CONTEXT ||
	nKey == KEY_ALT_TAB then
		UserBufferDeactivate ()
		;Press the key, as it was previously eaten
		If nKey == KEY_LEFT_WINDOWS || nKey == KEY_RIGHT_WINDOWS then ; StartMenu
			ActivateStartMenu ()
		ElIf NKey == KEY_CONTEXT then
			TypeKey (cKs23)
		EndIf
	EndIf
EndIf
EndFunction

Script KeyboardHelp()
Let HelpKeys = 1 
SayFormattedMessage (ot_status, cmsg167_L, cmsg167_S) ; "Keyboard Help on"
let nKeyboardHelpSavedTypingEcho = GetJCFOption(OPT_TYPING_ECHO)
Let nKeyboardHelpSavePunctuation = GetJcfOption (OPT_PUNCTUATION)
SetJcfOption(OPT_TYPING_ECHO,1) ; echo characters
SetJcfOption (OPT_PUNCTUATION, 1); Almost no punctuation spoken but normal inflection
AddHook (HK_SCRIPT, "KeyboardHelpHook")
; ignore any keys not attached to scripts
TrapKeys(TRUE)
EndScript

Void Function KeyboardHelpHook (string ScriptName, string FrameName)
var
	string sMessageLong,
	string sMessageShort,
	string sText1
if (ScriptName == "KeyboardHelp") then
Let HelpKeys = 0
	SayFormattedMessage (ot_status, cmsg168_L, cmsg168_S) ; "Keyboard Help off"
	RemoveHook (HK_SCRIPT, "KeyboardHelpHook")
	TrapKeys(FALSE)
	SetJcfOption(OPT_TYPING_ECHO,nKeyboardHelpSavedTypingEcho)
	SetJcfOption (OPT_PUNCTUATION, nKeyboardHelpSavePunctuation)
	return FALSE
endIf
if IsSameScript () then
	if ((FrameName != cscNull) && (GetFrameDescription (FrameName) != cscNull)) then
		let sText1 = GetFrameDescription (FrameName)
	let sMessageLong = FormatString (cmsg173_L, sText1)
		SayFormattedMessage (ot_help, sMessageLong, sText1) ; "This frame "
	endIf
	if (FrameName == cscNull) then
		Say (GetScriptDescription(ScriptName), ot_help)
	endIf
else
	Say (GetCurrentScriptKeyName (), ot_help) ; says key name, "insert+up arrow"
	if (FrameName != cscNull) then
		let sMessageLong = FormatString (cmsg174_L, FrameName)
		SayFormattedMessage (ot_help, sMessageLong) ; "says the content of the frame "
		Say (GetFrameSynopsis (FrameName), ot_help)
	else
		Say (GetScriptSynopsis(ScriptName), ot_help)
	endIf
endIf
; by returning  FALSE, a hook function can prevent a script from being run
return FALSE
EndFunction

Void Function CloseWinmxWindow ()
SaveCursor ()
JAWSCursor ()
RouteJAWSToPc ()
JAWSPageUp ()
JAWSEnd ()
LeftMouseButton ()
RestoreCursor ()
EndFunction

Script GoToEditSearch ()
Var
Handle HWnd

If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
If GetControlID (getfocus()) == IdEditSearch && GetWindowClass(GetFocus()) == "edit" Then
Return
Else let hwnd = FindDescendantWindow(GetFirstChild(GetForegroundWindow()), IdEditSearch)
If GetWindowClass(HWnd) == "Edit" then
SetFocus (HWnd)
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
EndIf
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndScript

Script GoToResultsOrDownloadsList ()
Var
Handle HWnd,
Int IdWnd

Let IdWnd = GetControlID (getfocus()) 
If (IdWnd == IdResultsList || IdWnd == IdDownloadsList) 
&& GetWindowClass(GetFocus()) == "SysListView32" Then
Return
Else let hwnd = FindDescendantWindow(GetFirstChild(GetForegroundWindow()), IdDownloadsList)
If GetWindowClass(HWnd) == "SysListView32" then
SetFocus (HWnd)
SayFormattedMessage (OT_SELECT, DownloadsList)
Else If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
Let HWnd = FindWindow (GetFirstChild(GetForegroundWindow()), "SysListView32", "")  
If HWnd != 0 Then
SetFocus (Hwnd)
SayFormattedMessage (OT_SELECT, ResultsList)
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndIf
EndIf
EndScript

Script GoToUploadsList ()
Var
Handle HWnd

If GetControlID (getfocus()) == IdUploadsList&& GetWindowClass(GetFocus()) == "SysListView32" Then
Return
Else let hwnd = FindDescendantWindow(GetFirstChild(GetForegroundWindow()), IdUploadsList)
If GetWindowClass(HWnd) == "SysListView32" Then
SetFocus (HWnd)
SayFormattedMessage (OT_select, UploadsList)
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
EndIf
EndScript

Script StartSearch ()
var
Handle HWnd

If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
let HWnd = FindDescendantWindow (GetFirstChild(GetForegroundWindow ()), IdStartSearch)
If GetWindowClass(HWnd) == "button" Then
SaveCursor ()
MoveToWindow (HWnd)
Pause ()
LeftMouseButton ()
RestoreCursor ()
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndScript

Script SearchInNewWnd ()
var
Handle hwnd

If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
let hwnd = FindDescendantWindow (GetFirstChild(GetForegroundWindow ()), IdSearchInNewWnd)
if GetWindowClass (hwnd) == "button" then
SaveCursor ()
MoveToWindow (hwnd)
Pause ()
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_select, SearchInNewWindow)
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndScript

Script StopSearch ()
var
handle hwnd

If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
let hwnd = FindDescendantWindow (GetFirstChild(GetForegroundWindow ()), IdStopSearch)
if GetWindowClass (hwnd)== "button" then
SaveCursor ()
MoveToWindow (hwnd)
Pause ()
LeftMouseButton ()
RestoreCursor ()
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndScript

Script CloseSearch ()
var
handle hwnd

If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
let hwnd = FindDescendantWindow (GetFirstChild(GetForegroundWindow ()), IdCloseSearch)
If GetWindowClass (hwnd)== "button" then
SaveCursor ()
MoveToWindow (hwnd)
Pause ()
LeftMouseButton ()
RestoreCursor ()
SayFormattedMessage (OT_select, CloseSearchWnd)
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndScript

Script StartDownload ()
var
handle hwnd

If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
let hwnd = FindDescendantWindow (GetFirstChild(GetForegroundWindow ()), IdDownload)
if GetWindowClass (hwnd)== "button" then
SaveCursor ()
MoveToWindow (hwnd)
Pause ()
LeftMouseButton ()
RestoreCursor ()
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndScript

Void Function AutoStartEvent ()
If FirstStart == 0 Then
let FirstStart = 1
SayMessage (OT_APP_START, StartMsg)
EndIf
SetFocus (LastFocusedWindow)
EndFunction

Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
	handle RealWindow,
	string RealWindowName,
	handle AppWindow,
Int IdFocusedWnd

Let LastFocusedWindow = FocusWindow
Let IdFocusedWnd = GetControlID (FocusWindow) 
If IdFocusedWnd >= 1500 && IdFocusedWnd <= 1537 Then
SayFocusedWindow ()
Else
;original function
let RealWindow = GetRealWindow (FocusWindow)
let RealWindowName = GetWindowName (RealWindow)
let AppWindow = GetAppMainWindow (FocusWindow)
if (GlobalPrevApp != AppWindow && AppWindow != FocusWindow) then
	; we've switched to a different app main window,
	; and it does not have the focus, so announce it
	If ! GlobalWasHjDialog then
		SayWindowTypeAndText (AppWindow)
	EndIf
endIf
If ((GlobalPrevRealName != RealWindowName) ; name has changed
|| (GlobalPrevReal != RealWindow)) then ; or handle has changed, then
	If ((RealWindow != AppWindow) && (RealWindow != FocusWindow)) then
		If ! GlobalWasHjDialog &&
		! GISuppressStartMenu then
			;GlobalWasHjDialog prevents over chatter, especially when exiting a list box and returning to a client area.
			;Set to FALSE when one HjDialog follows another
			;Example:
			;AddBrailleColors function
			;The GISuppressStartMenu function set to TRUE on account of the Real Window Name in Windows XP
			SayWindowTypeAndText (RealWindow)
		EndIf
	endIf
endIf
let GlobalFocusWindow = FocusWindow
;************
;This branch of code is now legacy.
;*** You can change it in your app-specific code,
;*****or leave it as it is without consequence.
;*********You will still find this block, or its derivatives
;********** in Freedom Scientific Code.
;***We are making the change to accomodate the more expansive use of
;****** the SayWindowTypeAndText function
;********Note that we have not changed the old functionality of 
;******* The SayFocusedWindow function
;if (GlobalPrevFocus != focusWindow &&
;   GetWindowTypeCode(focusWindow) != WT_TOOLBAR &&
;   GetWindowSubTypeCode(focusWindow) != WT_CONTEXTMENU) then
;	If GlobalWasHjDialog && ! InHjDialog () then
;		;Avoid reading titles over and over and over ...
;		If ! UserBufferIsActive () then; Virtual.jsb handles this
;			SayLine ()
;		EndIf
;	ElIf GetWindowSubTypeCode(FocusWindow) == wt_StartMenu  then
;		;	need to handle submenus of start menu and moving from level to level here
;		if not giSuppressStartMenu then
;			SayObjectActiveItem()
;		endIf
;	Else
;		SayFocusedWindow () ; will use global variable GlobalFocusWindow
;	EndIf
;else
;	SayFocusedObject ()
;endIf
;****** End of legacy code*
;
;If in Start Menu,
;And not in Win NT or 95,
; Speak Object Name instead of the whole Object Type And Text information
If GetWindowSubTypeCode (FocusWindow) == WT_STARTMENU ||
;Windows XP, the Type code is ListView, so
RealWindowName == cWnStartMenu then
	If GISuppressStartMenu &&
	! iWin95 then
		Say (GetObjectName (), OT_CONTROL_NAME)
	EndIf
	;Solve Japan problem where
	;Exit Documents menus was not reporting accurate state.
	Let GISuppressStartMenu = TRUE
Else
	;Turn off Start Menu flag,
	;As we are not in the Start Menu, probably launched application or simply exited
	Let GISuppressStartMenu = FALSE; 
	SayFocusedWindow ()
EndIf
;above perform will return here to finish this routine
;now set all the global variables for next time.
let GlobalPrevReal = RealWindow
let GlobalPrevRealName = RealWindowName
let GlobalPrevApp = AppWindow
let GlobalPrevFocus = FocusWindow
Let GlobalWasHjDialog = InHjDialog ()
;end original function
EndIf
EndFunction

Script ShortcutHelp ()
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
if IsSameScript () Then 
SayFormattedMessage (OT_USER_BUFFER, ScriptInfo, "")
else SayFormattedMessage (OT_USER_BUFFER, shortcut, "")
EndIf
EndScript

Script SayStatusBar ()
If GetControlID (GetFocus ()) == IdDownloadsList && GetWindowClass (GetFocus ()) == "SysListView32" Then
SpeechOff ()
savecursor ()
invisiblecursor ()
MoveTo (GetWindowLeft(GetFocus()), GetWindowBottom (GetFocus()))
nextline ()
SpeechOn ()
SayLine ()
RestoreCursor ()
else PerformScript SayBottomLineOfWindow()
EndIf
EndScript
 
Script UppArrow ()
if GetWindowClass(GetFocus()) == "SysListView32" && IsPCCursor () && UserBufferIsActive () == false Then 
PriorLine ()
SayLine ()
else PerformScript SayPriorLine()
EndIf
EndScript
 
Script DownArrow ()
if GetWindowClass(GetFocus()) == "SysListView32" && IsPCCursor () && UserBufferIsActive () == false Then 
NextLine ()
SayLine ()
else PerformScript SayNextLine()
EndIf
EndScript
 
Int Function IsSearchWindow (handle hwnd)
var
handle HWindow,
String SWindow

let HWindow = FindDescendantWindow(HWnd, IdStartSearch)
if HWindow == 0 then
return false
Else let SWindow = stringlower(GetWindowName(HWindow)) 
if SWindow == "search" || SWindow == SearchButton Then
return true
else return false
EndIf
EndIf
EndFunction

String Function GetSearchWindows ()
var
string wName,
string ItemsList ,
handle checkedWnd

let ItemsList = NewSearch
let checkedWnd = GetFirstChild (GetForegroundWindow ())
While checkedWnd != 0
If IsSearchWindow (CheckedWnd) Then
let wName = GetWindowName(CheckedWnd)
if wName == "" || wName == "\"\" \"\"" Then
let wName = NoName 
EndIf
while StringContains (ItemsList, WName) != 0  
let WName = WName + " "
EndWhile
let ItemsList = ItemsList + "|" + wName
EndIf
let checkedWnd = GetNextWindow (checkedWnd) 
EndWhile
return ItemsList 
EndFunction

Script OpenNewSearch ()
Var
Handle HWnd

If IsSearchWindow (GetFirstChild (GetForegroundWindow ())) Then
SaveCursor ()
If FindString (GetFirstChild (GetForegroundWindow ()), "Open New Search", s_top, s_unrestricted) &&
GetWindowClass (GetCurrentWindow()) != "edit" Then
LeftMouseButton ()
elIf FindString (GetFirstChild (GetForegroundWindow ()), SearchNew, s_top, s_unrestricted) Then
LeftMouseButton ()
EndIf
RestoreCursor ()
/* inizio esclusione
If GetControlID (getfocus()) == IdEditSearch && GetWindowClass(GetFocus()) == "edit" Then
SaveCursor ()
JAWSCursor ()
RouteJAWSToPc ()
PriorLine ()
PriorLine ()
JAWSHome ()
LeftMouseButton ()
RestoreCursor ()
return
Else let hwnd = FindDescendantWindow(GetFirstChild(GetForegroundWindow()), IdEditSearch)
If GetWindowClass(HWnd) == "Edit" then
SpeechOff ()
SetFocus (HWnd)
Pause ()
SaveCursor ()
JAWSCursor ()
RouteJAWSToPc ()
PriorLine ()
PriorLine ()
JAWSHome ()
SpeechOn ()
LeftMouseButton ()
RestoreCursor ()
Else SayFormattedMessage (Ot_Error, FindError1)
EndIf
EndIf
fine esclusione*/
Else SayFormattedMessage (Ot_Error, NotSearchWindow)
EndIf
EndScript
